class Cryptonewbie::CLI

  def call
    Cryptonewbie::Scraper.new.make_cryptos
    start
  end

  def list
    puts ""
    puts "************* Today's Crypto-Market *************"
    puts ""
    Cryptonewbie::Crypto.all.each.with_index(1) do |crypto, i|
      puts "                   #{i}. #{crypto.name}"
    end
    puts ""
  end

  def start
    list
    input = nil
    while input != "exit"
      puts "Enter the (NAME) or (#) of the CryptoCurrency you'd like more info on!"
      puts ""
      puts "           Enter list to see the Top-5 again!"
      puts "                          OR"
      puts "           Enter exit to end the program."
      puts ""
      input = gets.strip

      if input == "list"
        list
      elsif input.to_i == 0
        if crypto = Cryptonewbie::Crypto.find_by_name(input)
          print_crypto(crypto)
          puts ""
          puts "Would you like to see another cryptocurrency? ENTER Y or N"
          input = gets.strip.downcase
          if input == "y"
            start
          else
            goodbye
            exit
          end
        end
      elsif input.to_i < 6
        if crypto = Cryptonewbie::Crypto.find(input.to_i)
          print_crypto(crypto)
          puts ""
          puts "Would you like to see another cryptocurrency? ENTER Y or N"
          input = gets.strip.downcase
          if input == "y"
            start
          else
            goodbye
            exit
          end
        end
      else
        list
      end
    end
    goodbye
  end

  def print_crypto(crypto)
    puts ""
    puts "--------- #{crypto.name} ---------"

    puts ""
    puts "Current Price: $#{crypto.price}"
    puts ""

    puts "Circulating Supply: #{crypto.circulating_supply}"
    puts ""

    puts "Percent-Change in last 24HR(s): #{crypto.change}%"
    puts ""

    puts "Website: #{crypto.website}"
    puts ""
  end

  def goodbye
    puts ""
    puts "PLEASE RETURN AT ANY TIME TO VIEW THE TOP 5 CRYPTOCURRENCIES!"
    puts ""
  end

end
