class Cryptonewbie::Crypto
  attr_accessor :name, :price, :circulating_supply, :change, :url, :website

  @@all = []

  def self.new_from_index_page(coin)
      self.new(
      coin.css('a.currency-name-container').text,
      "https://coinmarketcap.com#{coin.css("a").attribute("href").text}"
      )
  end

  def initialize(name = nil, url = nil)
    @name = name
    @url = url
    @@all << self
  end

  def self.all
    @@all
  end

  def self.find_by_name(name)
    self.all.detect do |crypto|
      crypto.name.downcase.strip == name.downcase.strip
    end
  end

  def self.find(input)
    self.all[input - 1]
  end

  def doc
   @doc ||= Nokogiri::HTML(open(self.url))
  end

  def price
    @price ||= doc.css("span#quote_price span.text-large2").text
  end

  def circulating_supply
    @circulating_supply ||= doc.css("div.col-sm-8.col-sm-push-4 div:nth-child(4) span").text.strip
  end

  def change
    @change ||= doc.css("div.col-xs-6.col-sm-8.col-md-4.text-left span:nth-child(2) span").text
  end

  def website
    @website ||= doc.css("ul.list-unstyled li:nth-child(1) a").attribute("href").text
  end

end
